Grid Filtering and Sorting - HTML UI Elements for Mobile & Web Applications | www.HtmlElements.com

Grid for Angular

Angular standalone version of this topic (compatible with Angular 17+). Import both the Smart UI component and module in the standalone component.

What this topic covers: Focuses on combining filtering and sorting rules, preserving user intent, and keeping large datasets readable and performant.

import { Component, ViewChild, ViewEncapsulation } from '@angular/core';
import { CommonModule } from '@angular/common';
import { RouterOutlet } from '@angular/router';
import { GridComponent, GridModule } from 'smart-webcomponents-angular/grid';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [CommonModule, GridModule, RouterOutlet],
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css'],
  encapsulation: ViewEncapsulation.None
})
export class AppComponent {
  @ViewChild('grid', { read: GridComponent, static: false }) grid!: GridComponent;
}
<!-- app.component.html -->
<smart-grid #grid></smart-grid>

Use this.grid for API methods in this topic.

Grid Filtering

Smart.Grid allows users to filter the data loaded from the Grid's data source through the user interface or programmatically. Filtering is controlled via the property/object filtering. To enable it, filtering.enabled has to be set to true.

Filter Menu

Filtering through the UI can be done through the filter menu (part of the column menu), which is configured via filtering.filterMenu. If filtering.filterMenu.visible is set to true, the filter menu can be opened by clicking the menu button in a column's header:

The filter menu allows filtering a column by two data fields and selecting filter condition, filter value and filter operator (or or and). Available filter conditions are determined by the data type of the column's data field.

Once the button "OK" is pressed, the filter is applied to the Grid.

Programmatic Filtering

A default filter in Grid can be applied by setting filtering.filter to an array, each member of which is an array with first member - data field to filter by and second member - filter expression:

filtering: {
    enabled: true,
    filter: [
        ['firstName', 'contains Andrew or contains Nancy'],
        ['quantity', '>= 3 and <= 8']
    ]
},

Filter can be applied in the columns definitions by using the column's 'filter' property.

columns: [
	{
		label: 'First Name', dataField: 'firstName', filterMenuMode: 'excel'
	},
	{ label: 'Last Name', filter: '= Davolio', dataField: 'lastName' },
	{ label: 'Date', dataField: 'date', align: 'right', cellsAlign: 'right', },
	{ label: 'Product', dataField: 'productName' },
	{ label: 'Quantity', filter: '> 5', dataField: 'quantity', align: 'right', cellsAlign: 'right', }
]

Excel-like Filtering. The filter menu can be displayed in default and excel mode. In the default mode, the filter menu displays 2 inputs for applying filters to the column. In excel-mode, it displays a list of check items for more precise filtering. To enable excel-like filtering, use this:

filtering: {
	enabled: true,
	filterMenu: {
		mode: 'excel'
	}
}
Alternatively, you can apply excel-like filtering to some of the columns by setting the column's "filterMenuMode" property.
label: 'First Name', dataField: 'firstName', filterMenuMode: 'excel'

Filter Row

You can enable filter row in its header by setting the grid's filtering->filterRow->visible property to true. Thus based on the data type of the underlying columns data, the Grid will render inputs for string values, numeric inputs or date pickers for filtering in the column headers.
 filtering: {
	enabled: true,
	filterRow: {
		visible: true
	}
}
 
grid filtering row

Filter Panel

The filter panel is another built-in type of filtering UI. The filters in this mode are displayed in the Grid's header panel and with a drop-down you can apply and clear all filters.

filtering: {
	enabled: true
},
header: {
	visible: true
}
 
grid filtering panel

Filter Expressions

A filter expression is a string that contains consecutively filter condition, filter value, filter operator (optional, for chaining multiple conditions). Supported filter conditions for use in expressions are:

  • '='
  • '<>'
  • '<'
  • '>'
  • '<='
  • '>='
  • 'equal'
  • 'not equal'
  • 'less than'
  • 'greater than'
  • 'greater than or equal'
  • 'less than or equal'
  • 'starts with'
  • 'ends with'
  • 'null'
  • ''
  • 'isblank'
  • 'isnotblank'
  • 'contains'
  • 'notcontains'
  • 'startswith'
  • 'endswith'
  • 'NULL'
  • 'NOT_NULL'

More information: property filtering in the Grid API documentation.

Filtering-related Methods:

  • addFilter - adds a filter. This method takes two parameters, corresponding to filtering.filter - data field and filter expression.
    					this.grid.addFilter("firstName","startsWith B");
    					
  • clearFilter - clears all applied filters, refreshes the view and updates all filter input components.
  • removeFilter - removes a column filter.

Grid Sorting

Smart.Grid allows users to sort the data loaded from the Grid's data source through the user interface or programmatically, by one or multiple columns. Sorting is controlled via the property/object sorting. To enable it, sorting.enabled has to be set to true.

Whether or not the Grid can be sorted by multiple columns is controlled by sorting.mode (which can be 'one' or 'many').

Sorting can be disabled for particular columns by setting allowSort to false in the column's definition. To sort a column by default, its sortOrder property has to be set to either 'asc' (ascending) or 'desc' (descending).

Sort UI

A Grid column can be sorted by clicking the column's header. The first click sorts ascending, the second one - descending and the third one clears the sorting. If sorting.sortToggleThreeStates is set to false, third click sorts ascending again (it does not remove sorting).

Sorting through the UI can also be done through the sort menu (part of the column menu) which can be opened by clicking the menu button in a column's header. The sort menu allows the options Sort ascending, Sort descending, and Remove Sort.


More information: property sorting in the Grid API documentation.

Sort Animation

Sort animation can be enabled by setting appearance.allowSortAnimation to true. The animation duration is controlled by setting appearance.sortAnimationDuration.

Sorting-related Methods:

For AI tooling

Developer Quick Reference

Topic: grid-filtering-sorting   Component: Grid   Framework: Angular

Main methods: addFilter()

Common config keys: header, filtering, columns

Implementation Notes

Compatibility: Angular 17+ (standalone)   API access pattern: @ViewChild(...) + this.component.method()

Lifecycle guidance: Bind inputs declaratively and call imperative API through @ViewChild in/after ngAfterViewInit.

Common pitfalls:

  • Using @ViewChild API too early (before view init).
  • Omitting standalone imports for Smart modules in @Component.imports.
  • Type mismatches between configuration fields and template bindings.

Validation checklist:

  • Ensure module import exists in standalone component imports array.
  • Use typed @ViewChild(..., { read: ComponentType }).
  • Call imperative methods after view initialization.

Grid Filtering and Sorting - HTML UI Elements for Mobile & Web Applications | www.HtmlElements.com

Grid for React

React version of this topic (compatible with React 19+). Keep the same configuration logic from JavaScript and pass it as component props.

What this topic covers: Focuses on combining filtering and sorting rules, preserving user intent, and keeping large datasets readable and performant.

import React, { useMemo, useRef } from 'react';
import { Grid } from 'smart-webcomponents-react/grid';
import 'smart-webcomponents-react/source/styles/smart.default.css';

export default function App() {
  const componentRef = useRef(null);
  const componentProps = useMemo(() => ({
    // Copy this topic's JavaScript configuration here.
  }), []);

  return <Grid ref={componentRef} {...componentProps}></Grid>;
}

Use componentRef.current for API methods in this topic.

Grid Filtering

Smart.Grid allows users to filter the data loaded from the Grid's data source through the user interface or programmatically. Filtering is controlled via the property/object filtering. To enable it, filtering.enabled has to be set to true.

Filter Menu

Filtering through the UI can be done through the filter menu (part of the column menu), which is configured via filtering.filterMenu. If filtering.filterMenu.visible is set to true, the filter menu can be opened by clicking the menu button in a column's header:

The filter menu allows filtering a column by two data fields and selecting filter condition, filter value and filter operator (or or and). Available filter conditions are determined by the data type of the column's data field.

Once the button "OK" is pressed, the filter is applied to the Grid.

Programmatic Filtering

A default filter in Grid can be applied by setting filtering.filter to an array, each member of which is an array with first member - data field to filter by and second member - filter expression:

filtering: {
    enabled: true,
    filter: [
        ['firstName', 'contains Andrew or contains Nancy'],
        ['quantity', '>= 3 and <= 8']
    ]
},

Filter can be applied in the columns definitions by using the column's 'filter' property.

columns: [
	{
		label: 'First Name', dataField: 'firstName', filterMenuMode: 'excel'
	},
	{ label: 'Last Name', filter: '= Davolio', dataField: 'lastName' },
	{ label: 'Date', dataField: 'date', align: 'right', cellsAlign: 'right', },
	{ label: 'Product', dataField: 'productName' },
	{ label: 'Quantity', filter: '> 5', dataField: 'quantity', align: 'right', cellsAlign: 'right', }
]

Excel-like Filtering. The filter menu can be displayed in default and excel mode. In the default mode, the filter menu displays 2 inputs for applying filters to the column. In excel-mode, it displays a list of check items for more precise filtering. To enable excel-like filtering, use this:

filtering: {
	enabled: true,
	filterMenu: {
		mode: 'excel'
	}
}
Alternatively, you can apply excel-like filtering to some of the columns by setting the column's "filterMenuMode" property.
label: 'First Name', dataField: 'firstName', filterMenuMode: 'excel'

Filter Row

You can enable filter row in its header by setting the grid's filtering->filterRow->visible property to true. Thus based on the data type of the underlying columns data, the Grid will render inputs for string values, numeric inputs or date pickers for filtering in the column headers.
 filtering: {
	enabled: true,
	filterRow: {
		visible: true
	}
}
 
grid filtering row

Filter Panel

The filter panel is another built-in type of filtering UI. The filters in this mode are displayed in the Grid's header panel and with a drop-down you can apply and clear all filters.

filtering: {
	enabled: true
},
header: {
	visible: true
}
 
grid filtering panel

Filter Expressions

A filter expression is a string that contains consecutively filter condition, filter value, filter operator (optional, for chaining multiple conditions). Supported filter conditions for use in expressions are:

  • '='
  • '<>'
  • '<'
  • '>'
  • '<='
  • '>='
  • 'equal'
  • 'not equal'
  • 'less than'
  • 'greater than'
  • 'greater than or equal'
  • 'less than or equal'
  • 'starts with'
  • 'ends with'
  • 'null'
  • ''
  • 'isblank'
  • 'isnotblank'
  • 'contains'
  • 'notcontains'
  • 'startswith'
  • 'endswith'
  • 'NULL'
  • 'NOT_NULL'

More information: property filtering in the Grid API documentation.

Filtering-related Methods:

  • addFilter - adds a filter. This method takes two parameters, corresponding to filtering.filter - data field and filter expression.
    					componentRef.current.addFilter("firstName","startsWith B");
    					
  • clearFilter - clears all applied filters, refreshes the view and updates all filter input components.
  • removeFilter - removes a column filter.

Grid Sorting

Smart.Grid allows users to sort the data loaded from the Grid's data source through the user interface or programmatically, by one or multiple columns. Sorting is controlled via the property/object sorting. To enable it, sorting.enabled has to be set to true.

Whether or not the Grid can be sorted by multiple columns is controlled by sorting.mode (which can be 'one' or 'many').

Sorting can be disabled for particular columns by setting allowSort to false in the column's definition. To sort a column by default, its sortOrder property has to be set to either 'asc' (ascending) or 'desc' (descending).

Sort UI

A Grid column can be sorted by clicking the column's header. The first click sorts ascending, the second one - descending and the third one clears the sorting. If sorting.sortToggleThreeStates is set to false, third click sorts ascending again (it does not remove sorting).

Sorting through the UI can also be done through the sort menu (part of the column menu) which can be opened by clicking the menu button in a column's header. The sort menu allows the options Sort ascending, Sort descending, and Remove Sort.


More information: property sorting in the Grid API documentation.

Sort Animation

Sort animation can be enabled by setting appearance.allowSortAnimation to true. The animation duration is controlled by setting appearance.sortAnimationDuration.

Sorting-related Methods:

For AI tooling

Developer Quick Reference

Topic: grid-filtering-sorting   Component: Grid   Framework: React

Main methods: addFilter()

Common config keys: header, filtering, columns

Implementation Notes

Compatibility: React 19+   API access pattern: const componentRef = useRef(null) + componentRef.current.method()

Lifecycle guidance: Use useMemo for large config objects and call imperative API through componentRef.current after first render.

Common pitfalls:

  • Recreating columns/dataSource objects on every render can reset component state.
  • Calling API methods before ref is available causes runtime errors.
  • Mixing controlled and imperative updates without sync can lead to stale UI.

Validation checklist:

  • Keep config objects memoized when possible.
  • Guard API calls with ref existence checks.
  • Verify CSS theme import is present once per app.

Grid Filtering and Sorting - HTML UI Elements for Mobile & Web Applications | www.HtmlElements.com

Grid for Vue

Vue 3 version using Smart custom elements and template refs.

What this topic covers: Focuses on combining filtering and sorting rules, preserving user intent, and keeping large datasets readable and performant.

<script setup>
import { onMounted, ref } from 'vue';
import 'smart-webcomponents/source/styles/smart.default.css';
import 'smart-webcomponents/source/modules/smart.grid.js';

const component = ref();
const componentProps = {
  // Copy this topic's JavaScript configuration here.
};

onMounted(() => {
  Object.assign(component.value, componentProps);
});
</script>

<template>
  <smart-grid ref="component"></smart-grid>
</template>

Use component.value for API methods in this topic.

Grid Filtering

Smart.Grid allows users to filter the data loaded from the Grid's data source through the user interface or programmatically. Filtering is controlled via the property/object filtering. To enable it, filtering.enabled has to be set to true.

Filter Menu

Filtering through the UI can be done through the filter menu (part of the column menu), which is configured via filtering.filterMenu. If filtering.filterMenu.visible is set to true, the filter menu can be opened by clicking the menu button in a column's header:

The filter menu allows filtering a column by two data fields and selecting filter condition, filter value and filter operator (or or and). Available filter conditions are determined by the data type of the column's data field.

Once the button "OK" is pressed, the filter is applied to the Grid.

Programmatic Filtering

A default filter in Grid can be applied by setting filtering.filter to an array, each member of which is an array with first member - data field to filter by and second member - filter expression:

filtering: {
    enabled: true,
    filter: [
        ['firstName', 'contains Andrew or contains Nancy'],
        ['quantity', '>= 3 and <= 8']
    ]
},

Filter can be applied in the columns definitions by using the column's 'filter' property.

columns: [
	{
		label: 'First Name', dataField: 'firstName', filterMenuMode: 'excel'
	},
	{ label: 'Last Name', filter: '= Davolio', dataField: 'lastName' },
	{ label: 'Date', dataField: 'date', align: 'right', cellsAlign: 'right', },
	{ label: 'Product', dataField: 'productName' },
	{ label: 'Quantity', filter: '> 5', dataField: 'quantity', align: 'right', cellsAlign: 'right', }
]

Excel-like Filtering. The filter menu can be displayed in default and excel mode. In the default mode, the filter menu displays 2 inputs for applying filters to the column. In excel-mode, it displays a list of check items for more precise filtering. To enable excel-like filtering, use this:

filtering: {
	enabled: true,
	filterMenu: {
		mode: 'excel'
	}
}
Alternatively, you can apply excel-like filtering to some of the columns by setting the column's "filterMenuMode" property.
label: 'First Name', dataField: 'firstName', filterMenuMode: 'excel'

Filter Row

You can enable filter row in its header by setting the grid's filtering->filterRow->visible property to true. Thus based on the data type of the underlying columns data, the Grid will render inputs for string values, numeric inputs or date pickers for filtering in the column headers.
 filtering: {
	enabled: true,
	filterRow: {
		visible: true
	}
}
 
grid filtering row

Filter Panel

The filter panel is another built-in type of filtering UI. The filters in this mode are displayed in the Grid's header panel and with a drop-down you can apply and clear all filters.

filtering: {
	enabled: true
},
header: {
	visible: true
}
 
grid filtering panel

Filter Expressions

A filter expression is a string that contains consecutively filter condition, filter value, filter operator (optional, for chaining multiple conditions). Supported filter conditions for use in expressions are:

  • '='
  • '<>'
  • '<'
  • '>'
  • '<='
  • '>='
  • 'equal'
  • 'not equal'
  • 'less than'
  • 'greater than'
  • 'greater than or equal'
  • 'less than or equal'
  • 'starts with'
  • 'ends with'
  • 'null'
  • ''
  • 'isblank'
  • 'isnotblank'
  • 'contains'
  • 'notcontains'
  • 'startswith'
  • 'endswith'
  • 'NULL'
  • 'NOT_NULL'

More information: property filtering in the Grid API documentation.

Filtering-related Methods:

  • addFilter - adds a filter. This method takes two parameters, corresponding to filtering.filter - data field and filter expression.
    					component.value.addFilter("firstName","startsWith B");
    					
  • clearFilter - clears all applied filters, refreshes the view and updates all filter input components.
  • removeFilter - removes a column filter.

Grid Sorting

Smart.Grid allows users to sort the data loaded from the Grid's data source through the user interface or programmatically, by one or multiple columns. Sorting is controlled via the property/object sorting. To enable it, sorting.enabled has to be set to true.

Whether or not the Grid can be sorted by multiple columns is controlled by sorting.mode (which can be 'one' or 'many').

Sorting can be disabled for particular columns by setting allowSort to false in the column's definition. To sort a column by default, its sortOrder property has to be set to either 'asc' (ascending) or 'desc' (descending).

Sort UI

A Grid column can be sorted by clicking the column's header. The first click sorts ascending, the second one - descending and the third one clears the sorting. If sorting.sortToggleThreeStates is set to false, third click sorts ascending again (it does not remove sorting).

Sorting through the UI can also be done through the sort menu (part of the column menu) which can be opened by clicking the menu button in a column's header. The sort menu allows the options Sort ascending, Sort descending, and Remove Sort.


More information: property sorting in the Grid API documentation.

Sort Animation

Sort animation can be enabled by setting appearance.allowSortAnimation to true. The animation duration is controlled by setting appearance.sortAnimationDuration.

Sorting-related Methods:

For AI tooling

Developer Quick Reference

Topic: grid-filtering-sorting   Component: Grid   Framework: Vue

Main methods: addFilter()

Common config keys: header, filtering, columns

Implementation Notes

Compatibility: Vue 3+   API access pattern: const component = ref() + component.value.method()

Lifecycle guidance: Use template refs with